<i18n lang="yml">
  en:
    previous: "previous"
    next: "next"
  nl:
    previous: "vorige"
    next: "volgende"
</i18n>

<template>
  <div
    v-if="numberOfPages > 1"
    :class="$style['pagination']"
  >
    <transition-group tag="div" name="fade-items" class="flex justify-center items-center">
      <div
        v-if="currentPageIndex > 0 && numberOfPages >= 7"
        key="btnPrevious"
        :class="[$style['button'], $style['previous']]"
        @click="$emit('to-page', currentPageIndex - 1)"
      >
        <SvgCaret width="18px" height="18px" style="transform: translateY(-2px) rotate(180deg); margin-right: 0.5em;" /> {{ $t("previous") }}
      </div>
      <template v-for="(page, index) in pagesList">
        <div
          v-if="numberOfPages >= 7 && (index === pagesList.length - 1 && currentPageIndex < numberOfPages - 3)"
          :key="`ellipsis_left_${page}_${index}`"
          :class="[$style['button'], $style['ellipsis']]"
        >
          …
        </div>
        <div
          v-if="page"
          :key="`page_${page}_${index}`"
          :class="[
            $style['button'],
            currentPageIndex === index ? $style['active'] : null,
          ]"
          @click="$emit('to-page', typeof page === 'number' ? page - 1 : null)"
        >
          {{ page }}
        </div>
        <div
          v-if="numberOfPages >= 7 && (index === 0 && currentPageIndex > 2)"
          :key="`ellipsis_right_${page}_${index}`"
          :class="[$style['button'], $style['ellipsis']]"
        >
          …
        </div>
      </template>
      <div
        v-if="currentPageIndex < pagesList.length - 1 && numberOfPages >= 7"
        key="btnNext"
        :class="[$style['button'], $style['next']]"
        @click="$emit('to-page', currentPageIndex + 1)"
      >
        {{ $t("next") }} <SvgCaret width="18px" height="18px" style="transform: translateY(-2px); margin-left: 0.5em;" />
      </div>
    </transition-group>
  </div>
</template>

<script lang="ts">
import {
  computed,
  defineComponent,
} from "@nuxtjs/composition-api";

export default defineComponent({
  name: "AmsPagination",

  components: {
    // @ts-ignore
    SvgCaret: () => import("~/assets/img/ui/caret-right.svg"),
  },

  props: {
    numberOfPages: {
      type: Number,
      default: 1,
    },
    currentPageIndex: {
      type: Number,
      default: 0,
    },
  },

  setup (props) {
    const pagesList = computed(() => {
      const pages = [];

      for (let page = 0; page < props.numberOfPages; page++) {
        let value = null;

        if (props.numberOfPages >= 7) {
          if (page === 0 || page === props.numberOfPages - 1 || (page >= props.currentPageIndex - 1 && page <= props.currentPageIndex + 1)) {
            value = page + 1;
          }
        } else {
          value = page + 1;
        }

        pages.push(value);
      }

      return pages;
    });

    return {
      pagesList,
    };
  },
});
</script>

<style lang="postcss" module>
.pagination {
  @apply flex items-center justify-center mt-4 w-full;

  .button {
    padding-top: 3px;
    height: 22px;
    user-select: none;

    @apply flex justify-center items-center mx-2 px-2 cursor-pointer text-gray-900;

    &.next,
    &.previous {
      width: min-content;

      @apply font-bold text-black;
    }

    &.previous {
      @apply ml-0 pl-0;
    }

    &.next {
      @apply mr-0;
    }

    &.ellipsis {
      &:hover,
      &:focus {
        @apply cursor-default text-gray-900 no-underline;
      }
    }

    &.active {
      @apply bg-gray-600 text-gray-200;

      &:hover,
      &:focus {
        @apply cursor-default text-gray-200 no-underline;
      }
    }

    &:hover,
    &:focus {
      @apply text-red-800 underline;
    }
  }
}
</style>
